/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/RemoteIcon.jsx
var RemoteIcon_exports = {};
__export(RemoteIcon_exports, {
  default: () => RemoteIcon_default
});
module.exports = __toCommonJS(RemoteIcon_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport2 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport3 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:xmlserializer
var xmlserializer_exports = {};
__export(xmlserializer_exports, {
  default: () => xmlserializer_default
});
var defaultImport4 = __toESM(require("xmlserializer"));
__reExport(xmlserializer_exports, require("xmlserializer"));
var xmlserializer_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport5 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/visualization-context/IconContext
var IconContext_exports = {};
__export(IconContext_exports, {
  default: () => IconContext_default
});
var defaultImport6 = __toESM(require("@splunk/visualization-context/IconContext"));
__reExport(IconContext_exports, require("@splunk/visualization-context/IconContext"));
var IconContext_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:lodash/isNumber
var isNumber_exports = {};
__export(isNumber_exports, {
  default: () => isNumber_default
});
var defaultImport7 = __toESM(require("lodash/isNumber"));
__reExport(isNumber_exports, require("lodash/isNumber"));
var isNumber_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// src/style.js
var toPx = (number, defaultNumber = 0) => isNumber_default(number) ? `${number}px` : number || toPx(defaultNumber);
var toDimension = ({ width, height }) => {
  let css = "";
  if (width) {
    css = `width: ${toPx(width)};`;
  }
  if (height) {
    css = `${css}${width ? "\n" : ""}height: ${toPx(height)};`;
  }
  return css;
};

// src/iconUtils.js
var shouldChangeFill = ({ fillAttr, fillStyle, strokeAttr, strokeStyle }) => {
  const noneFillAttr = !!fillAttr && (fillAttr === "none" || fillAttr === "transparent");
  const noneFillStyle = !!fillStyle && (fillStyle === "none" || fillStyle === "transparent");
  const noFillHasStroke = !fillAttr && !fillStyle && (!!strokeAttr || !!strokeStyle);
  return !(noneFillAttr || noneFillStyle || noFillHasStroke);
};
var shouldChangeStroke = ({ fillAttr, fillStyle, strokeAttr, strokeStyle }) => {
  const noneStrokeAttr = !!strokeAttr && (strokeAttr === "none" || strokeAttr === "transparent");
  const noneStrokeStyle = !!strokeStyle && (strokeStyle === "none" || strokeStyle === "transparent");
  const hasFill = !!fillAttr || !!fillStyle;
  const noStroke = !strokeAttr && !strokeStyle;
  return !(noneStrokeAttr || noneStrokeStyle || hasFill || noStroke);
};
var b64EncodeUnicode = (str) => (
  // first we use encodeURIComponent to get percent-encoded UTF-8,
  // then we convert the percent encodings into raw bytes which
  // can be fed into btoa.
  btoa(encodeURIComponent(str).replace(/%([0-9A-F]{2})/g, (match, p1) => String.fromCharCode(`0x${p1}`)))
);

// src/RemoteIcon.jsx
var IconContainer = styled_components_default.div`
    ${(props) => toDimension({ width: props.width, height: props.height })};
    margin: auto;
    cursor: ${(props) => props.onClick ? "pointer" : "inherit"};
`;
var ColoredIcon = styled_components_default.img`
    ${(props) => toDimension({ width: props.width, height: props.height })};
    opacity: ${(props) => props.opacity || 1};
`;
var _RemoteIcon = class _RemoteIcon extends react_exports.PureComponent {
  constructor(props) {
    super(props);
    this.state = { iconDataURI: null };
  }
  // eslint-disable-next-line camelcase
  UNSAFE_componentWillMount() {
    this.getIcon(this.props.iconURL, this.props.color);
  }
  componentDidUpdate(prevProps) {
    if (prevProps.iconURL !== this.props.iconURL || prevProps.color !== this.props.color) {
      this.getIcon(this.props.iconURL, this.props.color);
    }
  }
  /**
   * Check if the iconURL is a registry URL/dataURI/direct URL and fetch from the registry when required
   * @param {String} iconURL
   * @param {String} color
   */
  getIcon(iconURL, color) {
    return __async(this, null, function* () {
      const getIconDataURI = () => __async(this, null, function* () {
        if (this.isRegistryURL(iconURL)) {
          const iconRegistry = this.context;
          if (iconRegistry) {
            try {
              const icon = yield iconRegistry.getByURL(iconURL);
              return icon.dataURI;
            } catch (error) {
              console.error((0, i18n_exports._)(error));
            }
          }
        } else {
          return iconURL;
        }
        return null;
      });
      const iconDataURI = yield getIconDataURI();
      if (color) {
        this.colorIcon(iconDataURI, color);
      } else {
        this.setState({ iconDataURI });
      }
    });
  }
  /**
   * check if icon is a registry url
   * @param {String} src
   */
  isRegistryURL(src = "") {
    const [type] = src.split("://");
    return type !== "http" && type !== "https" && !src.startsWith("data:image/svg+xml;base64");
  }
  /*
   * Color the icon:
   * parse svg elements from the dataURI, change color style of svg, and change fill/stroke attribute/style of each svg basic shapes
   * in the svg element to currentColor. At the end, convert the modified svg back to dataURI string.
   *
   * Limitation:
   * if the svg is created with multiple pathes with different fill attributes, this method would
   * convert all pathes' fill attribute to the color prop. It may change the view of the svg icon.
   *
   * @method colorIcon
   * @params {DataURI} dataURI
   * @params {String} color      e.g. 'red' || '#ffffff'
   */
  colorIcon(dataURI, color) {
    fetch(dataURI).then((response) => response.text()).then((text) => {
      const parser = new DOMParser();
      const xmlDoc = parser.parseFromString(text, "text/xml");
      const svg = xmlDoc.getElementsByTagName("svg")[0];
      const children = svg.querySelectorAll("*");
      svg.style.color = color;
      for (let i = 0; i < children.length; i += 1) {
        const child = children[i];
        if (_RemoteIcon.BASIC_SHAPES.includes(child.tagName)) {
          const fillAttr = child.getAttribute("fill");
          const fillStyle = child.style && child.style.fill;
          const strokeAttr = child.getAttribute("stroke");
          const strokeStyle = child.style && child.style.stroke;
          if (shouldChangeFill({ fillAttr, fillStyle, strokeAttr, strokeStyle })) {
            child.style.fill = "";
            child.setAttribute("fill", "currentColor");
          }
          if (shouldChangeStroke({ fillAttr, fillStyle, strokeAttr, strokeStyle })) {
            child.style.stroke = "";
            child.setAttribute("stroke", "currentColor");
          }
        }
      }
      const svgStr = b64EncodeUnicode(xmlserializer_default.serializeToString(svg));
      const iconDataURI = `data:image/svg+xml;base64,${svgStr}`;
      this.setState({ iconDataURI });
    }).catch(() => {
      console.error((0, i18n_exports._)("The icon cannot be colored properly."));
    });
  }
  render() {
    const { iconDataURI } = this.state;
    const { width, height, opacity, onIconClick } = this.props;
    if (!iconDataURI) {
      return null;
    }
    return /* @__PURE__ */ react_default.createElement(IconContainer, { width, height, onClick: onIconClick }, /* @__PURE__ */ react_default.createElement(
      ColoredIcon,
      {
        src: iconDataURI,
        alt: "Remote Icon",
        width,
        height,
        opacity,
        referrerPolicy: "no-referrer"
      }
    ));
  }
};
__publicField(_RemoteIcon, "contextType", IconContext_default);
__publicField(_RemoteIcon, "propTypes", {
  iconURL: prop_types_default.string,
  color: prop_types_default.string,
  width: prop_types_default.number,
  height: prop_types_default.number,
  opacity: prop_types_default.number,
  onIconClick: prop_types_default.func
});
__publicField(_RemoteIcon, "defaultProps", {
  width: 100,
  height: 100,
  opacity: 1
});
__publicField(_RemoteIcon, "BASIC_SHAPES", ["path", "rect", "circle", "ellipse", "line", "polyline", "polygon"]);
var RemoteIcon = _RemoteIcon;
var RemoteIcon_default = RemoteIcon;
//# sourceMappingURL=RemoteIcon.js.map
