/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/domUtils.js
var domUtils_exports = {};
__export(domUtils_exports, {
  computeTextSize: () => computeTextSize,
  getPropValue: () => getPropValue
});
module.exports = __toCommonJS(domUtils_exports);

// esm-externals:lodash/memoize
var memoize_exports = {};
__export(memoize_exports, {
  default: () => memoize_default
});
var defaultImport = __toESM(require("lodash/memoize"));
__reExport(memoize_exports, require("lodash/memoize"));
var memoize_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// src/domUtils.js
var computeTextSize = memoize_default(
  (text, font) => {
    const canvas = document.createElement("canvas");
    const context = canvas.getContext("2d");
    context.font = font;
    const measure = context.measureText(text);
    return measure.width;
  },
  (text, font) => `${text}${font}`
);
function getPropValue(element, property) {
  return window.getComputedStyle(element).getPropertyValue(property);
}
//# sourceMappingURL=domUtils.js.map
