/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/schemaUtils.ts
var schemaUtils_exports = {};
__export(schemaUtils_exports, {
  COLOR_OR_TOKEN_PATTERN: () => visualization_schemas_exports.COLOR_OR_TOKEN_PATTERN,
  COLOR_OR_TOKEN_PATTERN_WITH_RGBA: () => visualization_schemas_exports.COLOR_OR_TOKEN_PATTERN_WITH_RGBA,
  DYNAMIC_OPTIONS_DSL_PATTERN: () => visualization_schemas_exports.DYNAMIC_OPTIONS_DSL_PATTERN,
  TOKEN_PATTERN: () => visualization_schemas_exports.TOKEN_PATTERN,
  colorPattern: () => visualization_schemas_exports.colorPattern,
  colorPatternWithRGBA: () => visualization_schemas_exports.colorPatternWithRGBA,
  createTestSchema: () => visualization_schemas_exports.createTestSchema,
  default: () => visualization_schemas_exports.schemaDraft07,
  getPattern: () => visualization_schemas_exports.getPattern,
  rgbColorPattern: () => visualization_schemas_exports.rgbColorPattern,
  rgbaColorPattern: () => visualization_schemas_exports.rgbaColorPattern
});
module.exports = __toCommonJS(schemaUtils_exports);

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport ? defaultImport.default : defaultImport;
//# sourceMappingURL=schemaUtils.js.map
